## ring 20230206.0~ds2-1.3+11.0trisquel2

=== CMakeLists.txt ===
# Copyright (C) 2020-2023 Savoir-faire Linux Inc.
#
# Author: Albert Babí <albert.babi@savoirfairelinux.com>
# Author: Amin Bandali <amin.bandali@savoirfairelinux.com>
# Author: Mingrui Zhang <mingrui.zhang@savoirfairelinux.com>
# Author: Andreas Traczyk <andreas.traczyk@savoirfairelinux.com>
# Author: Kateryna Kostiuk <kateryna.kostiuk@savoirfairelinux.com>
# Author: Sébastien Blin <sebastien.blin@savoirfairelinux.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA.

cmake_minimum_required(VERSION 3.16)

if(APPLE)
  project(Jami)
else()
  project(jami)
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS_DEBUG "-Og -ggdb")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

option(WITH_DAEMON_SUBMODULE "Build with the daemon submodule" OFF)
option(WITH_WEBENGINE "Build with Qt WebEngine" ON)

# Main project directories:

# jami-daemon
if(WITH_DAEMON_SUBMODULE)
  set(DAEMON_DIR ${PROJECT_SOURCE_DIR}/daemon)
else()
  set(DAEMON_DIR ${PROJECT_SOURCE_DIR}/../daemon)
endif()
# src
set(LIBCLIENT_SRC_DIR ${PROJECT_SOURCE_DIR}/src/libclient)
set(APP_SRC_DIR ${PROJECT_SOURCE_DIR}/src/app)
# doc
set(DOC_DIR ${PROJECT_SOURCE_DIR}/doc)
# extras
set(EXTRAS_DIR ${PROJECT_SOURCE_DIR}/extras)
set(DATA_DIR ${EXTRAS_DIR}/data)
set(PACKAGING_DIR ${EXTRAS_DIR}/packaging)
set(SCRIPTS_DIR ${EXTRAS_DIR}/scripts)
# tests
set(TESTS_DIR ${PROJECT_SOURCE_DIR}/tests)

# Here we let find_package(<PackageName>...) try to find Qt 6,
# If it is found, find_package will succeed, and the CMake variable
# QT_VERSION_MAJOR will be defined 6.
if(QT6_VER AND QT6_PATH)
  find_package(QT NAMES Qt6 REQUIRED
    PATHS ${QT6_PATH} NO_DEFAULT_PATH)
else()
  find_package(QT NAMES Qt6 REQUIRED)
endif()
if (${QT_VERSION_MAJOR} STRLESS 6)
  if (${QT_VERSION_MINOR} STRLESS 2)
    message(FATAL_ERROR "Qt 6.2 or higher is required.")
  endif()
endif()

# libjamiclient
add_subdirectory(${LIBCLIENT_SRC_DIR})

set(QT_MODULES
  Quick
  Network
  NetworkAuth
  Svg
  Gui
  Qml
  QmlModels
  Sql
  Concurrent
  Core
  Core5Compat
  Multimedia
  Widgets
  Positioning)

if(WITH_WEBENGINE)
  list(APPEND QT_MODULES
    WebEngineCore
    WebEngineQuick
    WebChannel
    WebEngineWidgets)
endif()

set(CMAKE_CXX_FLAGS
  ${CMAKE_CXX_FLAGS} ${Qt6Widgets_EXECUTABLE_COMPILE_FLAGS})
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)

if (WITH_DAEMON_SUBMODULE AND NOT EXISTS ${DAEMON_DIR}/src)
  message(FATAL_ERROR
    "Jami Daemon sources not found in ${DAEMON_DIR}/src.  If you \
cloned this repository via git, perhaps you did not initialize its \
submodules afterwards.  You can do so by running \"git submodule \
update --init\" in the repository.")
endif()
set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH} "${EXTRAS_DIR}/build/cmake/modules")
find_package(LibJami REQUIRED)
if(LIBJAMI_FOUND)
  include_directories(${LIBJAMI_INCLUDE_DIRS})
endif()

include(FindPython3)
find_package(Python3 3.6 REQUIRED COMPONENTS Interpreter)
set(PYTHON_EXEC ${Python3_EXECUTABLE})

# Resource auto-gen
# QML and related code files
# Check files in the app's src directory and force a reconfigure if it
# changes.
# Only include webengine resources if specified.
if(WITH_WEBENGINE)
  set(GEN_QML_QRC_ARGS "--with-webengine")
endif()
file(GLOB_RECURSE
  QML_FILES CONFIGURE_DEPENDS
  ${APP_SRC_DIR}/*)
execute_process(
  COMMAND
  ${PYTHON_EXEC} ${SCRIPTS_DIR}/gen_qml_qrc.py ${GEN_QML_QRC_ARGS}
  WORKING_DIRECTORY ${APP_SRC_DIR})
set(QML_RESOURCES_QML ${APP_SRC_DIR}/qml.qrc)
# Image and misc. resources
# check files in the resources directory and force a reconfigure if it
# changes
file(GLOB_RECURSE
  RES_FILES CONFIGURE_DEPENDS
  ${PROJECT_SOURCE_DIR}/resources/*)
execute_process(
  COMMAND ${PYTHON_EXEC} ${SCRIPTS_DIR}/gen_resources_qrc.py
  WORKING_DIRECTORY ${APP_SRC_DIR})
set(QML_RESOURCES ${APP_SRC_DIR}/resources.qrc)

if (APPLE)
  include(FetchContent)
  FetchContent_Declare(
    libqrencode
    GIT_REPOSITORY https://github.com/fukuchi/libqrencode.git
    GIT_TAG v4.1.1)
  FetchContent_Populate(libqrencode)
  add_subdirectory(${libqrencode_SOURCE_DIR} ${libqrencode_BINARY_DIR})
  include_directories(${libqrencode_SOURCE_DIR})
endif()

# library compatibility (boost, libnotify, etc.)
add_definitions(-DQT_NO_KEYWORDS)

set(COMMON_SOURCES
  ${APP_SRC_DIR}/bannedlistmodel.cpp
  ${APP_SRC_DIR}/accountlistmodel.cpp
  ${APP_SRC_DIR}/networkmanager.cpp
  ${APP_SRC_DIR}/instancemanager.cpp
  ${APP_SRC_DIR}/main.cpp
  ${APP_SRC_DIR}/smartlistmodel.cpp
  ${APP_SRC_DIR}/utils.cpp
  ${APP_SRC_DIR}/mainapplication.cpp
  ${APP_SRC_DIR}/messagesadapter.cpp
  ${APP_SRC_DIR}/positionobject.cpp
  ${APP_SRC_DIR}/positionmanager.cpp
  ${APP_SRC_DIR}/accountadapter.cpp
  ${APP_SRC_DIR}/calladapter.cpp
  ${APP_SRC_DIR}/conversationsadapter.cpp
  ${APP_SRC_DIR}/avadapter.cpp
  ${APP_SRC_DIR}/contactadapter.cpp
  ${APP_SRC_DIR}/pluginadapter.cpp
  ${APP_SRC_DIR}/deviceitemlistmodel.cpp
  ${APP_SRC_DIR}/pluginlistmodel.cpp
  ${APP_SRC_DIR}/pluginhandlerlistmodel.cpp
  ${APP_SRC_DIR}/preferenceitemlistmodel.cpp
  ${APP_SRC_DIR}/mediacodeclistmodel.cpp
  ${APP_SRC_DIR}/currentaccounttomigrate.cpp
  ${APP_SRC_DIR}/audiodevicemodel.cpp
  ${APP_SRC_DIR}/pluginlistpreferencemodel.cpp
  ${APP_SRC_DIR}/audiomanagerlistmodel.cpp
  ${APP_SRC_DIR}/qmlregister.cpp
  ${APP_SRC_DIR}/utilsadapter.cpp
  ${APP_SRC_DIR}/moderatorlistmodel.cpp
  ${APP_SRC_DIR}/screensaver.cpp
  ${APP_SRC_DIR}/systemtray.cpp
  ${APP_SRC_DIR}/appsettingsmanager.cpp
  ${APP_SRC_DIR}/lrcinstance.cpp
  ${APP_SRC_DIR}/selectablelistproxymodel.cpp
  ${APP_SRC_DIR}/conversationlistmodelbase.cpp
  ${APP_SRC_DIR}/conversationlistmodel.cpp
  ${APP_SRC_DIR}/searchresultslistmodel.cpp
  ${APP_SRC_DIR}/calloverlaymodel.cpp
  ${APP_SRC_DIR}/filestosendlistmodel.cpp
  ${APP_SRC_DIR}/wizardviewstepmodel.cpp
  ${APP_SRC_DIR}/avatarregistry.cpp
  ${APP_SRC_DIR}/currentconversation.cpp
  ${APP_SRC_DIR}/currentaccount.cpp
  ${APP_SRC_DIR}/videodevices.cpp
  ${APP_SRC_DIR}/videoprovider.cpp
  ${APP_SRC_DIR}/callparticipantsmodel.cpp
  ${APP_SRC_DIR}/tipsmodel.cpp
  ${APP_SRC_DIR}/positioning.cpp
  ${APP_SRC_DIR}/currentcall.cpp)

set(COMMON_HEADERS
  ${APP_SRC_DIR}/avatarimageprovider.h
  ${APP_SRC_DIR}/networkmanager.h
  ${APP_SRC_DIR}/smartlistmodel.h
  ${APP_SRC_DIR}/updatemanager.h
  ${APP_SRC_DIR}/utils.h
  ${APP_SRC_DIR}/bannedlistmodel.h
  ${APP_SRC_DIR}/version.h
  ${APP_SRC_DIR}/accountlistmodel.h
  ${APP_SRC_DIR}/instancemanager.h
  ${APP_SRC_DIR}/connectivitymonitor.h
  ${APP_SRC_DIR}/jamiavatartheme.h
  ${APP_SRC_DIR}/mainapplication.h
  ${APP_SRC_DIR}/qrimageprovider.h
  ${APP_SRC_DIR}/messagesadapter.h
  ${APP_SRC_DIR}/positionobject.h
  ${APP_SRC_DIR}/positionmanager.h
  ${APP_SRC_DIR}/accountadapter.h
  ${APP_SRC_DIR}/calladapter.h
  ${APP_SRC_DIR}/conversationsadapter.h
  ${APP_SRC_DIR}/qmladapterbase.h
  ${APP_SRC_DIR}/avadapter.h
  ${APP_SRC_DIR}/contactadapter.h
  ${APP_SRC_DIR}/pluginadapter.h
  ${APP_SRC_DIR}/deviceitemlistmodel.h
  ${APP_SRC_DIR}/pluginlistmodel.h
  ${APP_SRC_DIR}/pluginhandlerlistmodel.h
  ${APP_SRC_DIR}/preferenceitemlistmodel.h
  ${APP_SRC_DIR}/mediacodeclistmodel.h
  ${APP_SRC_DIR}/currentaccounttomigrate.h
  ${APP_SRC_DIR}/audiodevicemodel.h
  ${APP_SRC_DIR}/pluginlistpreferencemodel.h
  ${APP_SRC_DIR}/audiomanagerlistmodel.h
  ${APP_SRC_DIR}/qmlregister.h
  ${APP_SRC_DIR}/abstractlistmodelbase.h
  ${APP_SRC_DIR}/quickimageproviderbase.h
  ${APP_SRC_DIR}/qtutils.h
  ${APP_SRC_DIR}/utilsadapter.h
  ${APP_SRC_DIR}/moderatorlistmodel.h
  ${APP_SRC_DIR}/screensaver.h
  ${APP_SRC_DIR}/systemtray.h
  ${APP_SRC_DIR}/appsettingsmanager.h
  ${APP_SRC_DIR}/lrcinstance.h
  ${APP_SRC_DIR}/selectablelistproxymodel.h
  ${APP_SRC_DIR}/conversationlistmodelbase.h
  ${APP_SRC_DIR}/conversationlistmodel.h
  ${APP_SRC_DIR}/searchresultslistmodel.h
  ${APP_SRC_DIR}/calloverlaymodel.h
  ${APP_SRC_DIR}/filestosendlistmodel.h
  ${APP_SRC_DIR}/wizardviewstepmodel.h
  ${APP_SRC_DIR}/avatarregistry.h
  ${APP_SRC_DIR}/currentconversation.h
  ${APP_SRC_DIR}/currentaccount.h
  ${APP_SRC_DIR}/videodevices.h
  ${APP_SRC_DIR}/videoprovider.h
  ${APP_SRC_DIR}/callparticipantsmodel.h
  ${APP_SRC_DIR}/tipsmodel.h
  ${APP_SRC_DIR}/positioning.h
  ${APP_SRC_DIR}/currentcall.h)

if(WITH_WEBENGINE)
  list(APPEND COMMON_SOURCES
    ${APP_SRC_DIR}/previewengine.cpp)
  set(QML_WEBRESOURCES ${LIBCLIENT_SRC_DIR}/webresource.qrc)
  add_definitions(-DWITH_WEBENGINE)
else()
  list(APPEND COMMON_SOURCES
    ${APP_SRC_DIR}/nowebengine/previewengine.cpp)
endif()

# For libavutil/avframe.
set(LIBJAMI_CONTRIB_DIR "${DAEMON_DIR}/contrib")
find_path(AVUTIL_INCLUDE_DIR libavutil/avutil.h
  PATHS
  ${LIBJAMI_CONTRIB_DIR}/native/ffmpeg
  ${LIBJAMI_CONTRIB_DIR}/build/ffmpeg/Build/win32/x64/include)
include_directories(${AVUTIL_INCLUDE_DIR})

find_package(Vulkan)
if(Vulkan_FOUND)
  add_definitions(-DHAS_VULKAN)
  include_directories(${Vulkan_INCLUDE_DIR})
endif()

if(MSVC)
  set(WINDOWS_SYS_LIBS
    windowsapp.lib
    dwmapi.lib
    Shell32.lib
    Ole32.lib
    Advapi32.lib
    Shlwapi.lib
    User32.lib
    Gdi32.lib
    Crypt32.lib
    Strmiids.lib)

  list(APPEND COMMON_SOURCES
    ${APP_SRC_DIR}/connectivitymonitor.cpp
    ${APP_SRC_DIR}/updatemanager.cpp)
  # preprocessor defines
  add_definitions(-DUNICODE -DQT_NO_DEBUG -DNDEBUG)

  # dependencies
  set(QRENCODE_DIR
    ${PROJECT_SOURCE_DIR}/3rdparty/qrencode-win32/qrencode-win32)

  # compiler options
  add_compile_options(
    /wd4068 /wd4099 /wd4189 /wd4267 /wd4577 /wd4467 /wd4715 /wd4828)
  add_compile_options(
    /MP /GS /W3 /Gy /Zc:wchar_t /Zi /Gm- /O2 /Zc:inline /fp:precise)
  add_compile_options(/Gd /Oi /MD /FC /EHsc /nologo /sdl)

  # linker options
  add_link_options(
    "/IGNORE:4006,4049,4078,4098"
    "/FORCE:MULTIPLE"
    "/INCREMENTAL:NO"
    "/DEBUG"
    "/LTCG"
    "/NODEFAULTLIB:LIBCMT")

  # client deps
  set(QRENCODE_LIB
    ${QRENCODE_DIR}/vc8/qrcodelib/x64/Release-Lib/qrcodelib.lib)

  # daemon
  set(JAMID_SRC_PATH ${DAEMON_DIR}/contrib/msvc/include)
  set(JAMID_LIB ${DAEMON_DIR}/build/x64/ReleaseLib_win32/bin/jami.lib)
  set(GNUTLS_LIB ${DAEMON_DIR}/contrib/msvc/lib/x64/libgnutls.lib)

  # Beta config
  if(BETA)
    message(STATUS "Beta config enabled")
    add_definitions(-DBETA)
    set(JAMI_OUTPUT_DIRECTORY_RELEASE ${PROJECT_SOURCE_DIR}/x64/Beta)
  else()
    set(JAMI_OUTPUT_DIRECTORY_RELEASE
      ${PROJECT_SOURCE_DIR}/x64/Release)
  endif()

  include_directories(
    ${JAMID_SRC_PATH}
    ${LIBCLIENT_SRC_DIR}
    ${QRENCODE_DIR})
elseif (NOT APPLE)
  list(APPEND COMMON_SOURCES
    ${APP_SRC_DIR}/xrectsel.c
    ${APP_SRC_DIR}/connectivitymonitor.cpp
    ${APP_SRC_DIR}/dbuserrorhandler.cpp
    ${APP_SRC_DIR}/updatemanager.cpp)
  list(APPEND COMMON_HEADERS
    ${APP_SRC_DIR}/xrectsel.h
    ${APP_SRC_DIR}/dbuserrorhandler.h)
  list(APPEND QT_MODULES DBus)

  find_package(PkgConfig REQUIRED)

  pkg_check_modules(GLIB REQUIRED glib-2.0)
  if(GLIB_FOUND)
    add_definitions(${GLIB_CFLAGS_OTHER})
  endif()

  pkg_check_modules(GIO REQUIRED gio-2.0)
  if(GIO_FOUND)
    add_definitions(${GIO_CFLAGS})
  endif()

  pkg_check_modules(LIBNM libnm)
  if(LIBNM_FOUND)
    add_definitions(-DUSE_LIBNM)
  endif()

  pkg_check_modules(LIBNOTIFY libnotify>=0.7.6)
  if(LIBNOTIFY_FOUND)
    add_definitions(-DUSE_LIBNOTIFY)
    add_definitions(${LIBNOTIFY_CFLAGS})

=== debian/changelog ===
ring (20230206.0~ds2-1.3+11.0trisquel2) aramo; urgency=medium

  * Backport ring/jammi to aramo from mantic

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 24 Oct 2023 19:05:17 +0000

ring (20230206.0~ds2-1.3ubuntu0.1) mantic-security; urgency=medium

  * SECURITY UPDATE: Remote Code Execution
    - debian/patches/CVE-2021-37706.patch: fixed a RCE in PJSIP module
    - CVE-2021-37706
  * SECURITY UPDATE: Denial of Service
    - debian/patches/CVE-2023-27585.patch: fixed a buffer overflow in PJSIP
    - CVE-2023-27585

 -- Amir Naseredini <amir.naseredini@canonical.com>  Mon, 23 Oct 2023 15:12:57 +0100

ring (20230206.0~ds2-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/d5e6509975bfaa67f7b3c54db72336b810454fc2.patch:
    - gcc-13 upstream build fix (Closes: #1037842)
  * debian/patches/bfa5a93114266caf791ff62c84918249c6d75bdf.patch:
  * debian/patches/fc975f0cacde4b06c6adde3d7f0c02f71abfb38c.patch:
    - ffmpeg 6.0 upstream build fix.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Sep 2023 10:00:03 +0200

ring (20230206.0~ds2-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop unused Build-Depends: libpcre3-dev. (Closes: #999971)

 -- Bastian Germann <bage@debian.org>  Sat, 01 Jul 2023 23:23:01 +0200

=== debian/control ===
Source: ring
Section: comm
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Amin Bandali <bandali@gnu.org>
Build-Depends: debhelper-compat (= 12),
               autoconf,
               automake,
               cmake,
               libtool,
# trisquel's aramo dependencies
               libgl1-mesa-dev,
               libqt6opengl6-dev,
               libvulkan-dev,
               libxkbcommon-dev,
# Qt client
               libnotify-dev,
               libnm-dev,
               libqrencode-dev,
               libqt6core5compat6-dev,
               libqt6networkauth6-dev,
               libqt6svg6-dev,
               qml6-module-qt-labs-platform,
               qml6-module-qt-labs-qmlmodels,
               qml6-module-qt5compat-graphicaleffects,
               qml6-module-qtmultimedia,
               qml6-module-qtqml-workerscript,
               qml6-module-qtquick,
               qml6-module-qtquick-controls,
               qml6-module-qtquick-dialogs,
               qml6-module-qtquick-layouts,
               qml6-module-qtquick-shapes,
               qml6-module-qtquick-templates,
               qml6-module-qtquick-window,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-l10n-tools,
               qt6-multimedia-dev,
               qt6-positioning-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools,
# daemon
               libdbus-1-dev,
               libdbus-c++-dev,
               libupnp-dev,
               libgnutls28-dev (>= 3.4.14),
               libssl-dev,
               libpulse-dev,
               libasound2-dev,
               libexpat1-dev,
               libyaml-cpp-dev,
               libsndfile1-dev,
               libxext-dev,
               libxfixes-dev,
               libspeex-dev,
               libspeexdsp-dev,
               uuid-dev,
               libavcodec-dev,
               libavutil-dev (>= 7:3.4.2),
               libavformat-dev,
               libswscale-dev,
               libavdevice-dev,
               libopus-dev,
               libudev-dev,
               libgsm1-dev,
               libjsoncpp-dev,
               libnatpmp-dev,
               libva-dev,
               libopendht-dev (>= 2.4.12-5),
               libasio-dev,
               libcrypto++-dev,
               libargon2-dev,
               libvdpau-dev,
               libsecp256k1-dev,
               libfmt-dev,
               libhttp-parser-dev,
               libarchive-dev,
               libgit2-dev,
               libwebrtc-audio-processing-dev,
# other
               libmsgpack-cxx-dev | libmsgpack-dev (>= 1.4.2),
               libmsgpack-cxx-dev | libmsgpack-dev (<= 4.0.0),
               yasm,
               libsamplerate0-dev
Standards-Version: 4.6.2
Homepage: https://jami.net
Vcs-Git: https://salsa.debian.org/pkg-voip-team/ring.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/ring
Rules-Requires-Root: no

Package: jami
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libqt6multimediaquick6,
         libqt6quickshapes6,
         libqt6quicktemplates2-6,
         qt6-qpa-plugins,
         jami-daemon (=${binary:Version}),
         libqt6sql6-sqlite,
         qml6-module-qt-labs-platform,
         qml6-module-qt-labs-qmlmodels,
         qml6-module-qt5compat-graphicaleffects,
         qml6-module-qtmultimedia,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-dialogs,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-shapes,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-window
Provides: jami-qt
Description: Secure and distributed voice, video, and chat platform - desktop client
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree, Jami provides functionality similar to Telegram,
 BigBlueButton, Jitsi Meet, etc.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami desktop client, jami (aka jami-qt).

Package: jami-daemon
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Secure and distributed voice, video and chat platform - daemon
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree Jami provides similar functionality like Telegram,
 BigBlueButton, Jitsi Meet, etc do.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami daemon, jamid.

## ring 20231201.0~ds1

=== debian/changelog ===
ring (20231201.0~ds1-1) unstable; urgency=medium

  * New upstream release
  * debian/patches/CVE-2023-27585.patch: Drop patch for CVE-2023-27585
    now included in jami's pjproject downstream of the main pjproject
    upstream
  * debian/patches/2010-dont-force-build-pkgs.patch: Refresh
  * debian/control: Bump minimum version for libopendht-dev to 3.0.1
  * debian/rules: Explicitly disable libwrap
  * debian/control: Add libxkbcommon-dev to Build-Depends
  * debian/control: Add 'Recommends: qt6-wayland' for jami
    (Closes: #1035659)

 -- Amin Bandali <bandali@gnu.org>  Fri, 19 Jan 2024 21:53:59 -0500

ring (20230922.0~ds2-1) unstable; urgency=medium

  * Use system libraries for md4c and tidy (Closes: #1053933)
    - debian/copyright: Add 3rdparty/md4c/* and 3rdparty/tidy-html5/*
      to Files-Excluded.
    - debian/control: Add libmd4c-dev, libmd4c-html0-dev, and
      libtidy-dev to Build-Depends.
    - debian/patches/2020-system-md4c-tidy.patch: Patch to use system
      libraries for md4c and tidy, including using the correct include
      paths.
    - debian/source/lintian-overrides: Drop the no longer relevant
      overrides concerning 3rdparty/tidy-html5/.

 -- Amin Bandali <bandali@gnu.org>  Sat, 21 Oct 2023 13:22:30 -0400

ring (20230922.0~ds1-1) unstable; urgency=medium

  * New upstream release (Closes: #1051909)
  * Add patch for fixing CVE-2023-27585, which is already fixed in the
    main pjproject upstream of jami as well as in jami's vendored copy
    of pjproject, but not included as part of the 20230922.0 release
    - debian/patches/CVE-2023-27585.patch
  * Replace libdbus-c++-dev with libsdbus-c++-dev, following upstream
    - debian/control
  * Bump Build-Depends on libopendht-dev (>= 3.0.0)
    - debian/control
  * Drop upstream patches included in this new release, as well as one
    that is no longer needed
    - debian/patches/d5e6509975bfaa67f7b3c54db72336b810454fc2.patch
    - debian/patches/bfa5a93114266caf791ff62c84918249c6d75bdf.patch
    - debian/patches/fc975f0cacde4b06c6adde3d7f0c02f71abfb38c.patch
    - debian/patches/1010-cmake-options.patch
  * Add libsdbus-c++-bin to Build-Depends to get the sdbus-c++-xml2cpp
    utility needed by daemon/bin/Makefile.am
    - debian/control
  * Add libsystemd-dev to Build-Depends, needed to successfully link
    against sdbus-cpp
    - debian/control
  * Update atomic library workaround for armel and mipsel
    - debian/rules
  * Address lintian warning and errors
    - debian/copyright: Drop old entry to address:
      W: ring source: superfluous-file-pattern
      src/libclient/web-chatview/linkify* [debian/copyright:81]
    - debian/source/lintian-overrides: Silence superfluous errors like
      E: ring source: source-is-missing
      [3rdparty/tidy-html5/regression_testing/cases/github-cases/case-946@1.html]
  * Remove duplicate line
      - debian/rules
  * Update patch to remove fuzz so it applies cleanly
    - debian/patches/2000-jsoncpp-rename.patch
  * Drop no longer needed patch
    - debian/patches/2010-dont-build-gnutls.patch
  * Rename debian/patches/2020-dont-build-msgpack.patch to combine the
    diffs for disabling forced builds and add asio and natpmp
    - debian/patches/2010-dont-force-build-pkgs.patch
  * Bump Build-Depends on libgnutls28-dev (>= 3.6.7)
    - debian/control

 -- Amin Bandali <bandali@gnu.org>  Tue, 26 Sep 2023 22:24:18 -0400

=== debian/control ===
--- 
+++ 
@@ -1,31 +1,30 @@
 Source: ring
 Section: comm
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Amin Bandali <bandali@gnu.org>
 Build-Depends: debhelper-compat (= 12),
                autoconf,
                automake,
                cmake,
                libtool,
-# trisquel's aramo dependencies
-               libgl1-mesa-dev,
-               libqt6opengl6-dev,
-               libvulkan-dev,
-               libxkbcommon-dev,
 # Qt client
+               libmd4c-dev,
+               libmd4c-html0-dev,
                libnotify-dev,
                libnm-dev,
                libqrencode-dev,
                libqt6core5compat6-dev,
                libqt6networkauth6-dev,
                libqt6svg6-dev,
+               libtidy-dev,
+               libxkbcommon-dev,
                qml6-module-qt-labs-platform,
                qml6-module-qt-labs-qmlmodels,
                qml6-module-qt5compat-graphicaleffects,
                qml6-module-qtmultimedia,
                qml6-module-qtqml-workerscript,
+               qml6-module-qtquick3d-spatialaudio,
                qml6-module-qtquick,
                qml6-module-qtquick-controls,
                qml6-module-qtquick-dialogs,
@@ -33,6 +32,7 @@
                qml6-module-qtquick-shapes,
                qml6-module-qtquick-templates,
                qml6-module-qtquick-window,
+               qt6-5compat-dev,
                qt6-base-dev,
                qt6-declarative-dev,
                qt6-l10n-tools,
@@ -42,9 +42,11 @@
                qt6-tools-dev-tools,
 # daemon
                libdbus-1-dev,
-               libdbus-c++-dev,
+               libsdbus-c++-bin,
+               libsdbus-c++-dev,
+               libsystemd-dev,
                libupnp-dev,
-               libgnutls28-dev (>= 3.4.14),
+               libgnutls28-dev (>= 3.6.7),
                libssl-dev,
                libpulse-dev,
                libasound2-dev,
@@ -67,7 +69,7 @@
                libjsoncpp-dev,
                libnatpmp-dev,
                libva-dev,
-               libopendht-dev (>= 2.4.12-5),
+               libopendht-dev (>= 3.0.1),
                libasio-dev,
                libcrypto++-dev,
                libargon2-dev,
@@ -93,10 +95,6 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libqt6multimediaquick6,
-         libqt6quickshapes6,
-         libqt6quicktemplates2-6,
-         qt6-qpa-plugins,
          jami-daemon (=${binary:Version}),
          libqt6sql6-sqlite,
          qml6-module-qt-labs-platform,
@@ -104,6 +102,7 @@
          qml6-module-qt5compat-graphicaleffects,
          qml6-module-qtmultimedia,
          qml6-module-qtqml-workerscript,
+         qml6-module-qtquick3d-spatialaudio,
          qml6-module-qtquick,
          qml6-module-qtquick-controls,
          qml6-module-qtquick-dialogs,
@@ -112,6 +111,7 @@
          qml6-module-qtquick-templates,
          qml6-module-qtquick-window
 Provides: jami-qt
+Recommends: qt6-wayland
 Description: Secure and distributed voice, video, and chat platform - desktop client
  Jami is an end-to-end encrypted secure and distributed voice, video,
  and chat communication platform that requires no central server and

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Build with LFS (See #913186)
CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CXXFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

# Number of CPUS
NO_CPUS=$(shell nproc)
ifeq ($(NO_CPUS),0)
NO_CPUS=1
endif

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
# Re-create tarballs from tarballs-unpacked
	mkdir -p daemon/contrib/tarballs
	for i in $(CURDIR)/daemon/contrib/tarballs-unpacked/*; do \
	  projectname=`basename $$i` && \
	  cd $$i && tar -caf ../../tarballs/$$projectname * && \
	  echo "Repacked $$projectname"; \
	done

# Daemon configure
	mkdir -p daemon/contrib/native
	cd daemon/contrib/native && \
	  ../bootstrap \
	    --disable-downloads \
	    --no-checksums \
	    --disable-ogg \
	    --disable-flac \
	    --disable-gmp \
	    --disable-vorbis \
	    --disable-vorbisenc \
	    --disable-speex \
	    --disable-sndfile \
	    --disable-gsm \
	    --disable-speexdsp \
	    --disable-asio \
	    --disable-boost \
	    --disable-cryptopp \
	    --disable-ffmpeg \
	    --disable-restbed \
	    --disable-vpx \
	    --disable-x264 \
	    --disable-yaml-cpp \
	    --disable-opendht \
	    --disable-gnutls \
	    --disable-sdbus-cpp \
	    --disable-secp256k1 \
	    --disable-upnp \
	    --disable-restinio \
	    --disable-fmt \
	    --disable-http_parser \
	    --disable-libarchive \
	    --disable-natpmp \
	    --disable-libgit2 \
	    --disable-webrtc-audio-processing && \
	  make list && \
	  make -j$(NO_CPUS) V=1
ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel))
# Link atomic library
	sed -i '/jamid_LDADD/s/libjami.la/& -latomic/' \
	  daemon/bin/dbus/Makefile.am
endif
	cd daemon && \
	  ./autogen.sh && \
	  ./configure \
	    --prefix=/usr \
	    --disable-shared

# Qt client configure
	dh_auto_configure -- \
	  -DENABLE_LIBWRAP=false \
	  -DWITH_WEBENGINE=false

override_dh_auto_build:
# Daemon build
	make -C daemon -j$(NO_CPUS) V=1
	pod2man daemon/man/jamid.pod > daemon/jamid.1

# Qt client build
	dh_auto_build

override_dh_auto_clean:
# Generated contrib tarballs
	rm -rfv daemon/contrib/tarballs

# Daemon clean
	[ -f daemon/contrib/native/Makefile ] && \
	  make -C daemon/contrib/native distclean || true
	rm -rfv daemon/contrib/native
	rm -rfv daemon/jamid.1

# Qt client clean
	dh_auto_clean

override_dh_auto_install:
# Daemon install
	cd daemon && make DESTDIR=$(CURDIR)/debian/jami-daemon install
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/include
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/*.a
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/*.la
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/pkgconfig
	rm -rv  $(CURDIR)/debian/jami-daemon/usr/lib
# CMake files
	rm -rfv $(CURDIR)/debian/jami/usr/lib/cmake

# Qt client install
	dh_auto_install --destdir=$(CURDIR)/debian/jami

# Work around dak not liking files with timestamps too far in the past
execute_before_dh_strip_nondeterminism:
	find $(CURDIR)/debian/jami/ ! -newermt "jan 01, 2000" \
	  -exec touch --date="@$(SOURCE_DATE_EPOCH)" {} +


tmp_dir := $(shell mktemp -d)
version := $(shell dpkg-parsechangelog -ldebian/changelog | perl -ne \
                   'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\~ds.+)(?:\-\d+.*)};')
ds := $(shell dpkg-parsechangelog -ldebian/changelog | perl -ne \
              'print $$1 if m{^Version:\s+(?:\d+:)?(?:\d.*)(\~ds.+)(?:\-\d+.*)};')
pj := $(tmp_dir)/jami-*/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*

# Repack the tarball with contrib tarballs unpacked
get-orig-source:
# Download jami tarball
	if [ -n "$$GET_ORIG_SOURCE_OVERRIDE_USCAN_TARBALL" ]; then \
	  mv $$GET_ORIG_SOURCE_OVERRIDE_USCAN_TARBALL $(tmp_dir); \
	else \
	  uscan \
	    --rename \
	    --destdir=$(tmp_dir) \
	    --download-version $(version); \
	fi

# Unpack jami tarball
	tar -C $(tmp_dir) -xf $(tmp_dir)/*.tar.*

# Remove original tarball
	rm $(tmp_dir)/*.tar.*

# Unpack all of the orig tarballs into tarballs-unpacked
	cd $(tmp_dir)/jami-*/daemon/contrib && \
	  mkdir tarballs-unpacked && \
	  for i in `find tarballs/ -name "*.tar.*"`; do \
	    project_name=`basename $$i` && \
	    mkdir tarballs-unpacked/$$project_name && \
	    tar -C tarballs-unpacked/$$project_name -xf $$i && \
	    echo "Unpacked $$project_name"; \
	  done

# Exclude files
#   This does not exclude everything that we need to exclude; so
#   debian/copyright's Files-Excluded section also excludes files.
	rm -rf $(pj)/build/vs # not needed, Visual Studio files
	rm -f  $(pj)/pjmedia/src/pjmedia-audiodev/s60_g729_bitstream.h # non distributable
	rm -f  $(pj)/pjsip-apps/src/pjsua/android/gradle/wrapper/* # not needed
	rm -r  $(pj)/pjsip-apps/src/swig/java/android/gradle/wrapper/* # not needed
	rm -rf $(pj)/third_party/g7221 # non-distributable (requires a license from Polycom)
	rm -rf $(pj)/third_party/ilbc # non distributable (the version included with pjproject)
	rm -rf $(pj)/third_party/milenage # non distributable
	rm -rf $(pj)/third_party/BaseClasses # non distributable (?)
	rm -rf $(pj)/third_party/portaudio # not needed
	rm -rf $(pj)/third_party/speex # not needed
	rm -rf $(pj)/third_party/mp3 # not needed
	rm -rf $(pj)/third_party/gsm # not needed
	rm -rf $(pj)/third_party/bdsound # not needed

# Remove all contrib tarballs
	rm -rf $(tmp_dir)/jami-*/daemon/contrib/tarballs

# Create the new tarball
	cd $(tmp_dir) && \
	  tar -czf \
	    $(CURDIR)/../ring_$(version)$(ds).orig.tar.gz \
	    jami-*

# Remove the temporary directory
	rm -rf $(tmp_dir)
